#
# $Header: /home/ben/.cvs_rep/nds/Debug/monitor/Makefile.app,v 1.1.1.1 2006/09/06 10:13:19 ben Exp $
#

NDSTOOL = ndstool

PREFIX = arm-eabi-
CC = $(PREFIX)gcc
LD = $(PREFIX)ld
AR = $(PREFIX)ar
AS = $(PREFIX)as
OBJCOPY	= $(PREFIX)objcopy

ARCH = -mthumb-interwork -march=armv5te -mtune=arm946e-s

INC_DIRS = $(DEVKITPRO)/libnds/include ../include

CFLAGS	= -g -W -Wall -DARM9\
	 -fomit-frame-pointer\
	-ffast-math\
	$(ARCH) $(addprefix -I,$(INC_DIRS))

THUMB_CFLAGS = -mthumb $(CFLAGS)

ASFLAGS = -g $(ARCH)

LDFLAGS	= -specs=../build_things/ds_debug_arm9.specs -g $(ARCH) -mno-fpu

LIBS = debugnds9

#LIBDIRS = $(DEVKITPRO)/libnds/lib ../libs
LIBDIRS = ../libs

# the base name
base_name = test_app

sources = main.c

objects = $(sources:.c=.o)

thumb_source = some_thumb_code.c
thumb_object = $(thumb_source:.c=.o)


# the ARM7 and ARM9 binary files
arm9_elf_file = $(base_name).elf

.PHONY : all
all : $(arm9_elf_file)


# The arm9 map file
arm9_map_file = $(subst elf,map,$(arm9_elf_file))


# How to build the ARM elf stuff
$(arm9_elf_file) : $(objects) $(thumb_object) ds_debug_arm9_crt0.o
	$(CC) $(LDFLAGS) -Wl,-Map,$(arm9_map_file) $(addprefix -L,$(LIBDIRS)) \
		$(objects) $(thumb_object) $(addprefix -l,$(LIBS)) -o $@


# Make the object files
$(thumb_object) : $(thumb_source)
	@echo building $@ from $<
	$(CC) $(THUMB_CFLAGS) $< -c -o $@

%.o : %.asm
	$(CC) -x assembler-with-cpp -marm -c $< -o $@

%.o : %.c
	@echo building $@ from $<
	$(CC) $(CFLAGS) $< -c -o $@

.PHONY : clean
clean :
	-rm -f *.o
	-rm -f $(arm9_elf_file) $(arm9_map_file)


# Generate the dependencies
%.d: %.c
	set -e; $(CC) -MM $(CFLAGS) $< \
		| sed 's|\($*\)\.o[ :]*|\1.o $@ : |g' > $@; \
		[ -s $@ ] || rm -f $@

# include the dependencies files
include $(sources:.c=.d)
